const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const playlists = sequelize.define(
    'playlists',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

playlist_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"editorial",


"partner_curator",


"user"

        ],

      },

curator_name: {
        type: DataTypes.TEXT,
      
      

      },

playlist_url: {
        type: DataTypes.TEXT,
      
      

      },

genre_focus: {
        type: DataTypes.TEXT,
      
      

      },

mood_tags: {
        type: DataTypes.TEXT,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  playlists.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity























    db.playlists.hasMany(db.playlist_placements, {
      as: 'playlist_placements_playlist',
      foreignKey: {
          name: 'playlistId',
      },
      constraints: false,
    });






















//end loop



    db.playlists.belongsTo(db.distribution_platforms, {
      as: 'platform',
      foreignKey: {
        name: 'platformId',
      },
      constraints: false,
    });

    db.playlists.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.playlists.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.playlists.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return playlists;
};


